package org.fuseri.model.dto.exercise;

import jakarta.validation.Valid;
import jakarta.validation.constraints.NotBlank;
import jakarta.validation.constraints.NotNull;
import lombok.Getter;
import lombok.Setter;
import org.fuseri.model.dto.common.DomainObjectDto;

import java.util.List;
import java.util.Objects;

@Getter
@Setter
public class QuestionDto extends DomainObjectDto {

    @NotBlank
    private String text;

    @NotNull
    private long exerciseId;

    @Valid
    private List<AnswerDto> answers;

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (!(o instanceof QuestionDto that)) return false;
        return getExerciseId() == that.getExerciseId() && Objects.equals(getText(), that.getText()) && Objects.equals(getAnswers(), that.getAnswers());
    }

    @Override
    public int hashCode() {
        return Objects.hash(getText(), getExerciseId(), getAnswers());
    }
}
